/* 
   getmode.c (conforming K&R)
   returns uid, gid, size and mode-mask of a given file

   (w) 1994 by Wolfgang Stumvoll
            stumvoll@pool.informatik.rwth-aachen.de
*/

/* includes */ /*{{{C}}}*//*{{{*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
/*}}}*/

int main(argc,argv) int argc;char **argv;
{  int ret=0;

   struct stat result;

   if (stat(argv[1],&result))
     /* show usage */ /*{{{*/
     /*
        We print the usage-message on a stat-fail (probably caused
        by an incorrect/missing argument) ignoring the possibility of
        *real* stat-fail.
     */
     { fprintf(stderr,"Usage: getmode <filename>\n");
       fprintf(stderr,"   getmode returns uid, gid, size and mode-mask of a given file\n");
       fprintf(stderr,"   getmode is part of the smartlog package v3.5\n");
       fprintf(stderr,"   (c) 1994-97 by Michael 'Bytewurm' Weber (Michael.Weber@rising-systems.de)\n");
       ret=64;
     } 
     /*}}}*/
   else
     /* print uid, gid, size and mode-mask */ /*{{{*/
     fprintf
      ( stdout,
        "%d %d %ld %o\n",
        (int)result.st_uid,
        (int)result.st_gid,
        (long)result.st_size,
        (int)(result.st_mode&07777)
      );
     /*}}}*/

  return(ret);
}
