#
# smartlog @version@
# (c) 1994-1997 by Michael 'Bytewurm' Weber (Michael.Weber@rising-systems.de)
#

#{{{script}}}#{{{ startup
BEGIN { 
   SCRIPT="@installdir@/smartlog.sh"
   FS=":"
   #{{{ set emergency defaults
   #   
   # zip/zap/ext/dir/tmp & date are set by install.sh and probably represent
   # your systems' minimum configuration, they become active on a missing or 
   # incomplete @installdir@/smartlog.def
   #   
   hold_def=hold_wrk="hold=14"
   local_def=local_wrk="local=no"
   shift_def=shift_wrk="shift=no"
   comp_def=comp_wrk="comp=no"
   arch_def=arch_wrk="arch=none"
   ash_def=ash_wrk="ash='none'"
   bsh_def=bsh_wrk="bsh='none'"
   nsh_def=nsh_wrk="nsh='none'"
   zip_def=zip_wrk="zip=@zip@"
   zap_def=zap_wrk="zap=@zap@"
   ext_def=ext_wrk="ext=@ext@"
   dir_def=dir_wrk="dir=@dir@"
   tmp_def=tmp_wrk="tmp=@tmp@"
   date_def=date_wrk="date='`@date@`'"
   size_def=size_wrk="size=0"
   mode_def=mode_wrk="mode=+.+/+"
#}}}
   if (verbose==0)
      SCRIPT=SCRIPT" -q"
}
#}}}
#{{{ verbose comment
verbose==2 {
   if (file!=FILENAME) {
      file=FILENAME
      print("handling file "file) >>LOG
   }
   print("handling command '"$0"'") >>LOG
}
#}}}
#{{{ prepare lines for parsing
/^[ 	]*(#.*)?$/ { next }         # skip comment/blank lines

{ ORIGIN=$0 }                       # save origin for debugging

/^[ 	]*/ { sub("[ 	]*","") }   # cut leading blanks
/[ 	]*$/ { sub("[ 	]*$","") }  # cut trailing blanks
/#/ { sub("[ 	]*#.*","") }        # cut inline comments
#}}}
#{{{ overwrite defaults
#{{{ change hold default
/^hold=(def(ault)?)?$/ { hold_wrk=hold_def;next }
/^hold=[0-9]+$/ { hold_wrk=$0;next }
/^[0-9]+$/ { hold_wrk="hold="$0;next }
#}}}
#{{{ change local default
/^local=(def(ault)?)?$/ { local_wrk=local_def;next }
/^local=[nN]/ { local_wrk="local=no";next }
/^local(=[yY].*)?$/ { local_wrk="local=yes";next }
#}}}
#{{{ change shift default
/^shift=(def(ault)?)?$/ { shift_wrk=shift_def;next }
/^shift=[nN]/ { shift_wrk="shift=no";next }
/^shift(=[yY].*)?$/ { shift_wrk="shift=yes";next }
#}}}
#{{{ change comp default
/^comp(ress)?=(def(ault)?)?$/ { comp_wrk=comp_def;next }
/^comp(ress)?=[0-9]+$/ { comp_wrk="comp="substr($0,1+match($0,"="));next }
/^comp(ress)?=[nN]/ { comp_wrk="comp=no";next }
/^comp(ress)?(=[yY].*)?$/ { comp_wrk="comp=yes";next }
#}}}
#{{{ change ash default
/^ash=(def(ault)?)?$/ { ash_wrk=ash_def;next }
/^ash=[^']+$/ { ash_wrk="ash='"substr($0,5)"'";next }
#}}}
#{{{ change bsh default
/^bsh=(def(ault)?)?$/ { bsh_wrk=bsh_def;next }
/^bsh=[^']+$/ { bsh_wrk="bsh='"substr($0,5)"'";next }
#}}}
#{{{ change nsh default
/^nsh=(def(ault)?)?$/ { nsh_wrk=nsh_def;next }
/^nsh=[^']+$/ { nsh_wrk="nsh='"substr($0,5)"'";next }
#}}}
#{{{ change mode default
/^mode=(def(ault)?)?$/ { mode_wrk=mode_def;next }
/^mode=(([*0-9a-zA-Z]+[.][*0-9a-zA-Z]+(@crutch@[*0-9]+)?)|([*0-9]+))$/ { mode_wrk=$0;next }
#}}}
#{{{ change arch default
/^arch(ive)?=(def(ault)?)?$/ { arch_wrk=arch_def;next }
/^arch(ive)?=[^'"`* 	]+$/ { arch_wrk="arch="substr($0,1+match($0,"="));next }
#}}}
#{{{ change zip default
/^zip=(def(ault)?)?$/ { zip_wrk=zip_def;next }
/^zip=[^ 	'"`]+$/ { zip_wrk="zip="substr($0,5);next }
#}}}
#{{{ change zap default
/^zap=(def(ault)?)?$/ { zap_wrk=zap_def;next }
/^zap=[^ 	'"`]+$/ { zap_wrk="zap="substr($0,5);next }
#}}}
#{{{ change ext default
/^ext=(def(ault)?)?$/ { ext_wrk=ext_def;next }
/^ext=[^ 	'"`]+$/ { ext_wrk="ext="substr($0,5);next }
#}}}
#{{{ change dir default
/^dir=(def(ault)?)?$/ { dir_wrk=dir_def;next }
/^dir=[^ 	'"`]+$/ { dir_wrk="dir="substr($0,5);next }
#}}}
#{{{ change tmp default
/^tmp=(def(ault)?)?$/ { tmp_wrk=tmp_def;next }
/^tmp=[^ 	'"`]+$/ { tmp_wrk="tmp="substr($0,5);next }
#}}}
#{{{ change date default
/^date=(def(ault)?)?$/ { date_wrk=date_def;next }
/^date=[^' 	]+/ { date_wrk="date='"substr($0,6)"'";next }
#}}}
#{{{ change size default
/^size=(def(ault)?)?$/ { size_wrk=size_def;next }
/^size=[0-9]+$/ { size_wrk=$0;next }
#}}}
#{{{ DEFAULTS
/^DEFAULTS/ {
   hold_def=hold_wrk
   local_def=local_wrk
   shift_def=shift_wrk
   comp_def=comp_wrk
   arch_def=arch_wrk
   ash_def=ash_wrk
   bsh_def=bsh_wrk
   nsh_def=nsh_wrk
   zip_def=zip_wrk
   zap_def=zap_wrk
   ext_def=ext_wrk
   dir_def=dir_wrk
   tmp_def=tmp_wrk
   date_def=date_wrk
   size_def=size_wrk
   mode_def=mode_wrk
   next
}
#}}}
#}}}
#{{{ check and parse logfile-lines
#{{{ development backup of the monster
#/^logfile=[^:'"` 	]+[ 	]*(:[ 	]*(\
#(((local|shift|comp(ress)?)(=)?)(([ynYN][^'"` 	]*)|(def(ault)?))?)|\
#(((comp(ress)?|size|hold|mode)=)?(([*0-9]+)|(def(ault)?))?)|\
#((((z[ia]p|ext|dir|tmp|arch(ive)?)=))(([^'"` 	]*)|(def(ault)?))?)|\
#((([abn]sh|date)=)(([^']*)|(def(ault)?))?)|\
#(mode=[*0-9a-zA-Z]+[.][*0-9a-zA-Z]+(@crutch@[*0-9]+)?)\
#)[ 	]*)*$/ {
#}}}
/^logfile=[^:'"` 	]+[*]*[ 	]*(:[ 	]*((((local|shift|comp(ress)?)(=)?)(([ynYN][^'"` 	]*)|(def(ault)?))?)|(((comp(ress)?|size|hold|mode)=)?(([*0-9]+)|(def(ault)?))?)|((((z[ia]p|ext|dir|tmp|arch(ive)?)=))(([^'"` 	]*)|(def(ault)?))?)|((([abn]sh|date)=)(([^']*)|(def(ault)?))?)|(mode=[*0-9a-zA-Z]+[.][*0-9a-zA-Z]+(@crutch@[*0-9]+)?))[ 	]*)*$/ {
  #{{{ parse line and assign arguments
  #{{{ default init
  hold=hold_wrk
  local=local_wrk
  shift=shift_wrk
  comp=comp_wrk
  arch=arch_wrk
  ash=ash_wrk
  bsh=bsh_wrk
  nsh=nsh_wrk
  zip=zip_wrk
  zap=zap_wrk
  ext=ext_wrk
  dir=dir_wrk
  tmp=tmp_wrk
  date=date_wrk
  size=size_wrk
  mode=mode_wrk
#}}}
  for (i=1;i<=NF;i++) {
     v=$i
     #{{{ cut leading/trailing blanks
     sub("^[ 	]*","",v)
     sub("[ 	]*$","",v)
#}}}
     if (i==1)
        logfile="logfile="substr(v,9)
     else {
        #{{{ set hold arg
        if (match(v,"^hold=(def(ault)?)?$"))
           hold=hold_def
        else if (match(v,"^hold=[0-9]+$"))
           hold=v
        else if (match(v,"^[0-9]+$"))
           hold="hold="v
#}}}
        #{{{ set local arg
        else if (match(v,"^local=(def(ault)?)?$"))
           local=local_def
        else if (match(v,"^local=[nN]"))
           local="local=no"
        else if (match(v,"^local(=[yY].*)?$"))
           local="local=yes"
#}}}
        #{{{ set shift arg
        else if (match(v,"^shift=(def(ault)?)?$"))
           shift=shift_def
        else if (match(v,"^shift=[nN]"))
           shift="shift=no"
        else if (match(v,"^shift(=[yY].*)?$"))
           shift="shift=yes"
#}}}
        #{{{ set comp arg
        else if (match(v,"^comp(ress)?=(def(ault)?)?$"))
           comp=comp_def
        else if (match(v,"^comp(ress)?=[nN]"))
           comp="comp=no"
        else if (match(v,"^comp(ress)?(=[yY].*)?$"))
           comp="comp=yes"
        else if (match(v,"^comp(ress)?=[0-9]+$"))
           comp="comp="substr(v,1+match(v,"="))
#}}}
        #{{{ set shell args
#{{{  ash
        else if (match(v,"^ash=(def(ault)?)?$"))
           ash=ash_def
        else if (match(v,"^ash="))
           ash="ash='"substr(v,5)"'"
#}}}
#{{{  bsh
        else if (match(v,"^bsh=(def(ault)?)?$"))
           bsh=bsh_def
        else if (match(v,"^bsh="))
           bsh="bsh='"substr(v,5)"'"
#}}}
#{{{  nsh
        else if (match(v,"^nsh=(def(ault)?)?$"))
           nsh=nsh_def
        else if (match(v,"^nsh="))
           nsh="nsh='"substr(v,5)"'"
#}}}
#}}}
        #{{{ set mode arg
        else if (match(v,"^mode=(def(ault)?)?$"))
          mode=mode_def
        else if (match(v,"^mode=((([*0-9a-zA-Z]+[.][*0-9a-zA-Z]+@crutch@)?[*0-9]+)|([*0-9a-zA-Z]+[.][*0-9a-zA-Z]+))"))
          mode=v
#}}}
        #{{{ set size arg
        else if (match(v,"^size=(def(ault)?)?$"))
           size=size_def
        else if (match(v,"^size=[0-9]+$"))
           size=v
#}}}
        #{{{ set dir arg
        else if (match(v,"^dir=(def(ault)?)?$"))
           dir=dir_def
        else if (match(v,"^dir="))
           dir="dir="substr(v,5)
#}}}
        #{{{ set arch arg
        else if (match(v,"^arch(ive)?=(def(ault)?)?$"))
           arch=arch_def
        else if (match(v,"^arch(ive)?=\\*"))
           arch=arch substr(v,2+match(v,"="))
        else if (match(v,"^arch(ive)?="))
           arch="arch=" substr(v,1+match(v,"="))
#}}}
        #{{{ set zip arg
        else if (match(v,"^zip=(def(ault)?)?$"))
           zip=zip_def
        else if (match(v,"^zip="))
           zip="zip="substr(v,5)
#}}}
        #{{{ set zap arg
        else if (match(v,"^zap=(def(ault)?)?$"))
           zap=zap_def
        else if (match(v,"^zap="))
           zap="zap="substr(v,5)
#}}}
        #{{{ set ext arg
        else if (match(v,"^ext=(def(ault)?)?$"))
           ext=ext_def
        else if (match(v,"^ext="))
           ext="ext="substr(v,5)
#}}}
        #{{{ set tmp arg
        else if (match(v,"^tmp=(def(ault)?)?$"))
           tmp=tmp_def
        else if (match(v,"^tmp="))
           tmp="tmp="substr(v,5)
#}}}
        #{{{ set date arg
        else if (match(v,"^date=(def(ault)?)?$"))
           date=date_def
        else if (match(v,"^date="))
           date="date='"substr(v,6)"'"
#}}}
        #{{{ complain about invalid lines not catched by the regexp
        #        
        # I'm afraid there are some holes in the regexp ... 
        #        
        else {
           print("Invalid line in "FILENAME", line "FNR": "ORIGIN) >>LOG
           print("This line was not catched by the toplevel regular expression") >>LOG
           print("Please send a bug report.") >>LOG
           if (errstop==1) {
             print("Stopped on detected error.") >>LOG
             close(LOG)
             exit 1
           }
           next
        }
#}}}
     }
  }
#}}}
  #{{{ create commandline and call smartlog.sh
  gsub("[*]","+",mode) # we use '*' for user interface, but '+' is simpler to parse
  gsub("[*]","%-%",logfile) # same here using %-%, '*' is very hard to parse
  cmd=SCRIPT" "DQ logfile DQ" "DQ date DQ" "DQ mode DQ" "DQ hold DQ" "DQ local DQ" "DQ shift DQ" "DQ comp DQ" "DQ arch DQ" "DQ bsh DQ" "DQ nsh DQ" "DQ ash DQ" "DQ zip DQ" "DQ zap DQ" "DQ ext DQ" "DQ dir DQ" "DQ tmp DQ" "DQ size DQ" "DQ "sm_user="workdir DQ

  if (verbose==2) 
    print("calling '"cmd"'") >>LOG

  if (noexec==1)
     e=0
  else
     e=system(cmd)

  if (e!=0) { 
    gsub("%-%","*",logfile) 
    print("Archiving of "logfile" returned with exit code "e) >>LOG
  }
#}}}
  close(LOG)
  next
}
#}}}
#{{{ complain about invalid lines
{
   print("Invalid line in "FILENAME", line "FNR": "ORIGIN) >>LOG
   if (errstop==1) {
     print("Stopped on detected error.") >>LOG
     close(LOG)
     exit 1
   }
   next
}
#}}}
